diff -Naur openssl-1.0.0q.orig/crypto/rand/md_rand.c openssl-1.0.0q/crypto/rand/md_rand.c
--- openssl-1.0.0q.orig/crypto/rand/md_rand.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/md_rand.c	2017-04-25 16:23:40.603621127 +0200
@@ -115,11 +115,13 @@
 # endif
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
-#include "e_os.h"
+#include <openssl/e_os.h>
 
 #include <openssl/rand.h>
 #include "rand_lcl.h"
@@ -127,6 +129,9 @@
 #include <openssl/crypto.h>
 #include <openssl/err.h>
 
+#include "modules/libopeay/libopeay_arrays.h"
+#include "modules/libopeay/libopeay_implmodule.h"
+
 #ifdef BN_DEBUG
 # define PREDICT
 #endif
@@ -134,10 +139,39 @@
 /* #define PREDICT	1 */
 
 #define STATE_SIZE	1023
+
+#ifdef OPERA_SMALL_VERSION
+
+#if LIBOPEAY_RAND_STATE_SIZE != STATE_SIZE
+#error "Update modules/libopeay/libopeay_implmodule.h with the correct LIBOPEAY_RAND_STATE_SIZE"
+#endif
+
+OPENSSL_IMPLEMENT_GLOBAL(int,               md_rand__state_num);
+OPENSSL_IMPLEMENT_GLOBAL(int,               md_rand__state_index);
+OPENSSL_IMPLEMENT_GLOBAL(Libopeay_ImplementModuleData::md_rand__state_t,    md_rand__state);
+OPENSSL_IMPLEMENT_GLOBAL(Libopeay_ImplementModuleData::md_rand__md_t,       md_rand__md);
+OPENSSL_IMPLEMENT_GLOBAL(Libopeay_ImplementModuleData::md_rand__md_count_t, md_rand__md_count);
+OPENSSL_IMPLEMENT_GLOBAL(double,            md_rand__entropy);
+OPENSSL_IMPLEMENT_GLOBAL(int,               md_rand__initialized);
+OPENSSL_IMPLEMENT_GLOBAL(unsigned int,      md_rand__crypto_lock_rand);
+OPENSSL_IMPLEMENT_GLOBAL(CRYPTO_THREADID,   md_rand__locking_threadid);
+
+#define state_num        OPENSSL_GLOBAL_REF(md_rand__state_num)
+#define state_index      OPENSSL_GLOBAL_REF(md_rand__state_index)
+#define state            OPENSSL_GLOBAL_REF(md_rand__state)
+#define md               OPENSSL_GLOBAL_REF(md_rand__md)
+#define md_count         OPENSSL_GLOBAL_REF(md_rand__md_count)
+#define entropy          OPENSSL_GLOBAL_REF(md_rand__entropy)
+#define initialized      OPENSSL_GLOBAL_REF(md_rand__initialized)
+#define crypto_lock_rand OPENSSL_GLOBAL_REF(md_rand__crypto_lock_rand)
+#define locking_threadid OPENSSL_GLOBAL_REF(md_rand__locking_threadid)
+
+#else
+
 static int state_num=0,state_index=0;
-static unsigned char state[STATE_SIZE+MD_DIGEST_LENGTH];
-static unsigned char md[MD_DIGEST_LENGTH];
-static long md_count[2]={0,0};
+static unsigned char state[STATE_SIZE+MD_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
+static unsigned char md[MD_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
+static long md_count[2]={0,0}; /* ARRAY OK UNUSED 2009-05-25 yngve */
 static double entropy=0;
 static int initialized=0;
 
@@ -147,32 +181,41 @@
 /* access to lockin_thread is synchronized by CRYPTO_LOCK_RAND2 */
 static CRYPTO_THREADID locking_threadid; /* valid iff crypto_lock_rand is set */
 
+#endif
 
 #ifdef PREDICT
 int rand_predictable=0;
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 const char RAND_version[]="RAND" OPENSSL_VERSION_PTEXT;
+#endif
 
 static void ssleay_rand_cleanup(void);
 static void ssleay_rand_seed(const void *buf, int num);
 static void ssleay_rand_add(const void *buf, int num, double add_entropy);
 static int ssleay_rand_bytes(unsigned char *buf, int num);
 static int ssleay_rand_pseudo_bytes(unsigned char *buf, int num);
+#ifndef OPERA_SMALL_VERSION
 static int ssleay_rand_status(void);
+#endif
 
-RAND_METHOD rand_ssleay_meth={
-	ssleay_rand_seed,
-	ssleay_rand_bytes,
-	ssleay_rand_cleanup,
-	ssleay_rand_add,
-	ssleay_rand_pseudo_bytes,
-	ssleay_rand_status
-	}; 
+OPENSSL_PREFIX_CONST_ITEM(static, RAND_METHOD, rand_ssleay_meth, libopeay)
+	CONST_ITEM_ENTRY_START(seed,ssleay_rand_seed)
+	CONST_ITEM_ENTRY_SINGLE(bytes,ssleay_rand_bytes)
+	CONST_ITEM_ENTRY_SINGLE(cleanup,ssleay_rand_cleanup)
+	CONST_ITEM_ENTRY_SINGLE(add,ssleay_rand_add)
+	CONST_ITEM_ENTRY_SINGLE(pseudorand,ssleay_rand_pseudo_bytes)
+#ifndef OPERA_SMALL_VERSION
+	CONST_ITEM_ENTRY_SINGLE(status,ssleay_rand_status)
+#else
+	CONST_ITEM_ENTRY_SINGLE(status,NULL)
+#endif
+CONST_ITEM_ENTRY_END;
 
-RAND_METHOD *RAND_SSLeay(void)
+const RAND_METHOD *RAND_SSLeay(void)
 	{
-	return(&rand_ssleay_meth);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(rand_ssleay_meth));
 	}
 
 static void ssleay_rand_cleanup(void)
@@ -191,12 +234,12 @@
 	{
 	int i,j,k,st_idx;
 	long md_c[2];
-	unsigned char local_md[MD_DIGEST_LENGTH];
+	unsigned char local_md[MD_DIGEST_LENGTH]; /* ARRAY OK 2009-06-05 yngve */
 	EVP_MD_CTX m;
 	int do_not_lock;
 
 	/*
-	 * (Based on the rand(3) manpage)
+	 * (Based on the op_rand(3) manpage)
 	 *
 	 * The input is chopped up into units of 20 bytes (or less for
 	 * the last block).  Each of these blocks is run through the hash
@@ -232,7 +275,7 @@
 	md_c[0] = md_count[0];
 	md_c[1] = md_count[1];
 
-	memcpy(local_md, md, sizeof md);
+	op_memcpy(local_md, md, sizeof(md));
 
 	/* state_index <= state_num <= STATE_SIZE */
 	state_index += num;
@@ -328,14 +371,21 @@
 	ssleay_rand_add(buf, num, (double)num);
 	}
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(volatile int, stirred_pool);
+#define stirred_pool OPENSSL_GLOBAL_REF(stirred_pool)
+#endif
+
 static int ssleay_rand_bytes(unsigned char *buf, int num)
 	{
+#ifndef OPERA_SMALL_VERSION
 	static volatile int stirred_pool = 0;
+#endif
 	int i,j,k,st_num,st_idx;
 	int num_ceil;
 	int ok;
 	long md_c[2];
-	unsigned char local_md[MD_DIGEST_LENGTH];
+	unsigned char local_md[MD_DIGEST_LENGTH]; /* ARRAY OK 2009-06-05 yngve */
 	EVP_MD_CTX m;
 #ifndef GETPID_IS_MEANINGLESS
 	pid_t curr_pid = getpid();
@@ -361,7 +411,7 @@
 	num_ceil = (1 + (num-1)/(MD_DIGEST_LENGTH/2)) * (MD_DIGEST_LENGTH/2);
 
 	/*
-	 * (Based on the rand(3) manpage:)
+	 * (Based on the op_rand(3) manpage:)
 	 *
 	 * For each group of 10 bytes (or less), we do the following:
 	 *
@@ -444,7 +494,7 @@
 	st_num=state_num;
 	md_c[0] = md_count[0];
 	md_c[1] = md_count[1];
-	memcpy(local_md, md, sizeof md);
+	op_memcpy(local_md, md, sizeof(md));
 
 	state_index+=num_ceil;
 	if (state_index > state_num)
@@ -520,8 +570,10 @@
 	else
 		{
 		RANDerr(RAND_F_SSLEAY_RAND_BYTES,RAND_R_PRNG_NOT_SEEDED);
+#ifndef OPERA_SMALL_VERSION
 		ERR_add_error_data(1, "You need to read the OpenSSL FAQ, "
 			"http://www.openssl.org/support/faq.html");
+#endif
 		return(0);
 		}
 	}
@@ -544,6 +596,7 @@
 	return (ret);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static int ssleay_rand_status(void)
 	{
 	CRYPTO_THREADID cur;
@@ -591,3 +644,4 @@
 	
 	return ret;
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand.h openssl-1.0.0q/crypto/rand/rand.h
--- openssl-1.0.0q.orig/crypto/rand/rand.h	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand.h	2017-04-25 16:23:40.606621229 +0200
@@ -59,12 +59,16 @@
 #ifndef HEADER_RAND_H
 #define HEADER_RAND_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/ossl_typ.h>
 #include <openssl/e_os2.h>
 
 #if defined(OPENSSL_SYS_WINDOWS)
+#ifndef OPERA_SMALL_VERSION
 #include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 
 #ifdef  __cplusplus
@@ -97,7 +101,7 @@
 #ifndef OPENSSL_NO_ENGINE
 int RAND_set_rand_engine(ENGINE *engine);
 #endif
-RAND_METHOD *RAND_SSLeay(void);
+const RAND_METHOD *RAND_SSLeay(void);
 void RAND_cleanup(void );
 int  RAND_bytes(unsigned char *buf,int num);
 int  RAND_pseudo_bytes(unsigned char *buf,int num);
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_egd.c openssl-1.0.0q/crypto/rand/rand_egd.c
--- openssl-1.0.0q.orig/crypto/rand/rand_egd.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_egd.c	2017-04-25 16:23:40.607620239 +0200
@@ -54,7 +54,7 @@
  *
  */
 
-#include <openssl/e_os2.h>
+#include <openssl/cryptlib.h>
 #include <openssl/rand.h>
 #include <openssl/buffer.h>
 
@@ -95,11 +95,14 @@
  *   RAND_egd() is a wrapper for RAND_egd_bytes() with numbytes=255.
  */
 
-#if defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_VMS) || defined(OPENSSL_SYS_MSDOS) || defined(OPENSSL_SYS_VXWORKS) || defined(OPENSSL_SYS_NETWARE) || defined(OPENSSL_SYS_VOS) || defined(OPENSSL_SYS_BEOS)
+#if defined(MSWIN)
+/* No code needed, not used on windows */
+#elif !defined(OPENSSL_SYS_UNIX) || defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_VMS) || defined(OPENSSL_SYS_MSDOS) || defined(OPENSSL_SYS_VXWORKS) || defined(OPENSSL_SYS_NETWARE) || defined(OPENSSL_SYS_VOS) || defined(OPENSSL_SYS_BEOS)
 int RAND_query_egd_bytes(const char *path, unsigned char *buf, int bytes)
 	{
 	return(-1);
 	}
+#ifndef OPERA_SMALL_VERSION
 int RAND_egd(const char *path)
 	{
 	return(-1);
@@ -109,45 +112,58 @@
 	{
 	return(-1);
 	}
+#endif
 #else
 #include <openssl/opensslconf.h>
+#ifndef OPERA_SMALL_VERSION
 #include OPENSSL_UNISTD
 #include <sys/types.h>
+#endif // !OPERA_SMALL_VERSION
+
 #include <sys/socket.h>
+
+#ifndef OPERA_SMALL_VERSION
 #ifndef NO_SYS_UN_H
 # ifdef OPENSSL_SYS_VXWORKS
 #   include <streams/un.h>
 # else
 #   include <sys/un.h>
 # endif
-#else
-struct	sockaddr_un {
+#else /*NO_SYS_UN_H*/
+#endif /* NO_SYS_UN_H */
+#endif // !OPERA_SMALL_VERSION
+
+struct	sockaddr_unn {
 	short	sun_family;		/* AF_UNIX */
-	char	sun_path[108];		/* path name (gag) */
+	char	sun_path[108];		/* path name (gag) */ /* ARRAY OK 2009-05-25 yngve */
 };
-#endif /* NO_SYS_UN_H */
+
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
 #include <errno.h>
+#endif // !OPERA_SMALL_VERSION
 
 #ifndef offsetof
-#  define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
+#  define op_offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
 #endif
 
 int RAND_query_egd_bytes(const char *path, unsigned char *buf, int bytes)
 	{
 	int ret = 0;
-	struct sockaddr_un addr;
+	struct sockaddr_unn addr;
 	int len, num, numbytes;
 	int fd = -1;
 	int success;
-	unsigned char egdbuf[2], tempbuf[255], *retrievebuf;
+	unsigned char egdbuf[2];		/* ARRAY OK 2009-05-25 yngve */
+	unsigned char tempbuf[255];		/* ARRAY OK 2009-05-25 yngve */
+	unsigned char *retrievebuf;
 
-	memset(&addr, 0, sizeof(addr));
+	op_memset(&addr, 0, sizeof(addr));
 	addr.sun_family = AF_UNIX;
-	if (strlen(path) >= sizeof(addr.sun_path))
+	if (op_strlen(path) >= sizeof(addr.sun_path))
 		return (-1);
 	BUF_strlcpy(addr.sun_path,path,sizeof addr.sun_path);
-	len = offsetof(struct sockaddr_un, sun_path) + strlen(path);
+	len = op_offsetof(struct sockaddr_unn, sun_path) + op_strlen(path);
 	fd = socket(AF_UNIX, SOCK_STREAM, 0);
 	if (fd == -1) return (-1);
 	success = 0;
@@ -281,6 +297,7 @@
 	}
 
 
+#ifndef OPERA_SMALL_VERSION
 int RAND_egd_bytes(const char *path, int bytes)
 	{
 	int num, ret = 0;
@@ -298,6 +315,7 @@
 	{
 	return (RAND_egd_bytes(path, 255));
 	}
+#endif // !OPERA_SMALL_VERSION
 
 
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_err.c openssl-1.0.0q/crypto/rand/rand_err.c
--- openssl-1.0.0q.orig/crypto/rand/rand_err.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_err.c	2017-04-25 16:23:40.607620239 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/rand.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_lib.c openssl-1.0.0q/crypto/rand/rand_lib.c
--- openssl-1.0.0q.orig/crypto/rand/rand_lib.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_lib.c	2017-04-25 16:23:40.608620087 +0200
@@ -56,10 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/rand.h>
+
 #ifndef OPENSSL_NO_ENGINE
 #include <openssl/engine.h>
 #endif
@@ -68,8 +72,12 @@
 /* non-NULL if default_RAND_meth is ENGINE-provided */
 static ENGINE *funct_ref =NULL;
 #endif
+
+#ifndef OPERA_SMALL_VERSION
 static const RAND_METHOD *default_RAND_meth = NULL;
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int RAND_set_rand_method(const RAND_METHOD *meth)
 	{
 #ifndef OPENSSL_NO_ENGINE
@@ -82,9 +90,16 @@
 	default_RAND_meth = meth;
 	return 1;
 	}
+#endif // !OPERA_SMALL_VERSION
 
 const RAND_METHOD *RAND_get_rand_method(void)
 	{
+#ifdef OPERA_SMALL_VERSION
+
+	return RAND_SSLeay();
+
+#else
+
 	if (!default_RAND_meth)
 		{
 #ifndef OPENSSL_NO_ENGINE
@@ -105,9 +120,12 @@
 			default_RAND_meth = RAND_SSLeay();
 		}
 	return default_RAND_meth;
+
+#endif // OPERA_SMALL_VERSION
 	}
 
 #ifndef OPENSSL_NO_ENGINE
+#ifndef OPERA_SMALL_VERSION
 int RAND_set_rand_engine(ENGINE *engine)
 	{
 	const RAND_METHOD *tmp_meth = NULL;
@@ -127,6 +145,7 @@
 	funct_ref = engine;
 	return 1;
 	}
+#endif // !OPERA_SMALL_VERSION
 #endif
 
 void RAND_cleanup(void)
@@ -134,7 +153,9 @@
 	const RAND_METHOD *meth = RAND_get_rand_method();
 	if (meth && meth->cleanup)
 		meth->cleanup();
+#ifndef OPERA_SMALL_VERSION
 	RAND_set_rand_method(NULL);
+#endif // !OPERA_SMALL_VERSION
 	}
 
 void RAND_seed(const void *buf, int num)
@@ -167,6 +188,7 @@
 	return(-1);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int RAND_status(void)
 	{
 	const RAND_METHOD *meth = RAND_get_rand_method();
@@ -174,3 +196,4 @@
 		return meth->status();
 	return 0;
 	}
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_os2.c openssl-1.0.0q/crypto/rand/rand_os2.c
--- openssl-1.0.0q.orig/crypto/rand/rand_os2.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_os2.c	2017-04-25 16:23:40.609621331 +0200
@@ -53,6 +53,9 @@
  *
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
 #include "cryptlib.h"
 #include <openssl/rand.h>
 #include "rand_lcl.h"
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_unix.c openssl-1.0.0q/crypto/rand/rand_unix.c
--- openssl-1.0.0q.orig/crypto/rand/rand_unix.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_unix.c	2017-04-25 16:23:40.610620900 +0200
@@ -108,16 +108,19 @@
  * Hudson (tjh@cryptsoft.com).
  *
  */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #define USE_SOCKETS
-#include "e_os.h"
-#include "cryptlib.h"
+#include <openssl/e_os.h>
+#include <openssl/cryptlib.h>
 #include <openssl/rand.h>
 #include "rand_lcl.h"
 
 #if !(defined(OPENSSL_SYS_WINDOWS) || defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_VMS) || defined(OPENSSL_SYS_OS2) || defined(OPENSSL_SYS_VXWORKS) || defined(OPENSSL_SYS_NETWARE))
 
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
 #include <sys/time.h>
 #include <sys/times.h>
@@ -125,13 +128,19 @@
 #include <fcntl.h>
 #include <unistd.h>
 #include <time.h>
-#if defined(OPENSSL_SYS_LINUX) /* should actually be available virtually everywhere */
-# include <poll.h>
+#endif // !OPERA_SMALL_VERSION
+
+#if defined(OPENSSL_SYS_LINUX) && !defined(SYS_CAP_OP_POLL_IMPL) /* should actually be available virtually everywhere */
+#include <sys/poll.h>
+#define op_poll poll
 #endif
+
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
 #ifndef FD_SETSIZE
 # define FD_SETSIZE (8*sizeof(fd_set))
 #endif
+#endif /* !OPERA_SMALL_VERSION */
 
 #if defined(OPENSSL_SYS_VOS)
 
@@ -234,27 +243,30 @@
 	return 1;
 }
 #else /* !defined(__OpenBSD__) */
+
+#ifdef OPENSSL_SYS_UNIX /* Unknown UNIX */
+
 int RAND_poll(void)
 {
 	unsigned long l;
 	pid_t curr_pid = getpid();
 #if defined(DEVRANDOM) || defined(DEVRANDOM_EGD)
-	unsigned char tmpbuf[ENTROPY_NEEDED];
+	unsigned char tmpbuf[ENTROPY_NEEDED]; /* ARRAY OK 2009-05-25 yngve */
 	int n = 0;
 #endif
 #ifdef DEVRANDOM
-	static const char *randomfiles[] = { DEVRANDOM };
+	static const char * const randomfiles[] = { DEVRANDOM };
 	struct stat randomstats[sizeof(randomfiles)/sizeof(randomfiles[0])];
 	int fd;
 	unsigned int i;
 #endif
 #ifdef DEVRANDOM_EGD
-	static const char *egdsockets[] = { DEVRANDOM_EGD, NULL };
-	const char **egdsocket = NULL;
+	static const char * const egdsockets[] = { DEVRANDOM_EGD, NULL };
+	const char * const *egdsocket = NULL;
 #endif
 
 #ifdef DEVRANDOM
-	memset(randomstats,0,sizeof(randomstats));
+	op_memset(randomstats,0,sizeof(randomstats));
 	/* Use a random entropy pool device. Linux, FreeBSD and OpenBSD
 	 * have this. Use /dev/urandom if you can as /dev/random may block
 	 * if it runs out of random entries.  */
@@ -308,7 +320,7 @@
 				pset.events = POLLIN;
 				pset.revents = 0;
 
-				if (poll(&pset, 1, usec / 1000) < 0)
+				if (op_poll(&pset, 1, usec / 1000) < 0)
 					usec = 0;
 				else
 					try_read = (pset.revents & POLLIN) != 0;
@@ -401,7 +413,7 @@
 	l=getuid();
 	RAND_add(&l,sizeof(l),0.0);
 
-	l=time(NULL);
+	l=op_time(NULL);
 	RAND_add(&l,sizeof(l),0.0);
 
 #if defined(OPENSSL_SYS_BEOS)
@@ -419,6 +431,32 @@
 #endif
 }
 
+#else  /* Unknown OS, non-UNIX */
+
+int RAND_poll(void)
+	{
+	// Opera's random generator in stdlib is already initialized at this
+	// point, because stdlib is the first initialized module. Let's get
+	// some randomness from there by using op_rand(). This function is
+	// similar to the OpenSSL's function for OpenBSD.
+
+	const size_t RAND_COUNT = (ENTROPY_NEEDED + 3) / 4;
+	const size_t BUF_SIZE   = RAND_COUNT * 4;
+
+	INT32 buf[RAND_COUNT]; /* ARRAY OK 2012-02-23 alexeik */
+	OP_ASSERT(BUF_SIZE == sizeof(buf));
+	OP_ASSERT(ENTROPY_NEEDED <= BUF_SIZE);
+
+	for (size_t i = 0; i < RAND_COUNT; i++)
+		buf[i] = op_rand();
+
+	RAND_add(buf, BUF_SIZE, BUF_SIZE);
+
+	return 1;
+	}
+
+#endif /* OPENSSL_SYS_UNIX */
+
 #endif /* defined(__OpenBSD__) */
 #endif /* !(defined(OPENSSL_SYS_WINDOWS) || defined(OPENSSL_SYS_WIN32) || defined(OPENSSL_SYS_VMS) || defined(OPENSSL_SYS_OS2) || defined(OPENSSL_SYS_VXWORKS) || defined(OPENSSL_SYS_NETWARE)) */
 
diff -Naur openssl-1.0.0q.orig/crypto/rand/rand_win.c openssl-1.0.0q/crypto/rand/rand_win.c
--- openssl-1.0.0q.orig/crypto/rand/rand_win.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/rand_win.c	2017-04-25 16:23:40.612620595 +0200
@@ -109,14 +109,17 @@
  *
  */
 
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/rand.h>
 #include "rand_lcl.h"
 
 #if defined(OPENSSL_SYS_WINDOWS) || defined(OPENSSL_SYS_WIN32)
+#ifndef OPERA_SMALL_VERSION
 #include <windows.h>
+#endif /* !OPERA_SMALL_VERSION */
 #ifndef _WIN32_WINNT
 # define _WIN32_WINNT 0x0400
+# undef __WINCRYPT_H__
 #endif
 #include <wincrypt.h>
 #include <tlhelp32.h>
@@ -202,7 +205,7 @@
 /* Even though MSDN says _WIN32_WCE>=210, it doesn't seem to be available
  * in commonly available implementations prior 300... */
 	{
-	BYTE buf[64];
+	BYTE buf[64]; /* ARRAY OK 2009-06-05 yngve */
 	/* poll the CryptoAPI PRNG */
 	/* The CryptoAPI returns sizeof(buf) bytes of randomness */
 	if (CryptAcquireContextW(&hProvider, NULL, NULL, PROV_RSA_FULL,
@@ -239,7 +242,7 @@
 	CRYPTRELEASECONTEXT release = NULL;
 	NETSTATGET netstatget = NULL;
 	NETFREE netfree = NULL;
-	BYTE buf[64];
+	BYTE buf[64]; /* ARRAY OK 2009-06-05 yngve */
 
 	if (netapi)
 		{
@@ -487,6 +490,8 @@
 #else
 			if (heaplist_first(handle, &hlist))
 				{
+				int total_entrycnt = 1024;
+				DWORD end_of_run = GetTickCount()+300; /* Milliseconds // Will not work properly when it is about to wrap around, which happens every 49 days */
 				do
 					{
 					RAND_add(&hlist, hlist.dwSize, 3);
@@ -496,11 +501,18 @@
 						hlist.th32HeapID))
 						{
 						int entrycnt = 80;
-						do
+						do{
 							RAND_add(&hentry,
 								hentry.dwSize, 5);
-						while (heap_next(&hentry)
-							&& --entrycnt > 0);
+
+							if(total_entrycnt %6 == 0 && GetTickCount() > end_of_run)
+							{
+								total_entrycnt =0;
+								break;
+							}
+
+						}while (heap_next(&hentry)
+							&& --entrycnt > 0 && --total_entrycnt > 0);
 						}
 					} while (heaplist_next(handle, &hlist) 
 						&& (!good || (GetTickCount()-starttime)<MAXDELAY));
@@ -574,6 +586,7 @@
 	return(1);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int RAND_event(UINT iMsg, WPARAM wParam, LPARAM lParam)
         {
         double add_entropy=0;
@@ -593,8 +606,8 @@
                         static int lastx,lasty,lastdx,lastdy;
                         int x,y,dx,dy;
 
-                        x=LOWORD(lParam);
-                        y=HIWORD(lParam);
+                        x=(int)(short)LOWORD(lParam);
+                        y=(int)(short)HIWORD(lParam);
                         dx=lastx-x;
                         dy=lasty-y;
                         if (dx != 0 && dy != 0 && dx-lastdx != 0 && dy-lastdy != 0)
@@ -619,16 +632,29 @@
 	RAND_poll();
 	readscreen();
 }
+#endif
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(int, have_perfc);
+#define have_perfc OPENSSL_GLOBAL_REF(have_perfc)
+#if defined(_MSC_VER) && defined(_M_X86)
+OPENSSL_IMPLEMENT_GLOBAL(int, have_tsc);
+#define have_tsc OPENSSL_GLOBAL_REF(have_tsc)
+#endif
+#endif
 
 /* feed timing information to the PRNG */
 static void readtimer(void)
 {
 	DWORD w;
 	LARGE_INTEGER l;
+#ifndef OPERA_SMALL_VERSION
 	static int have_perfc = 1;
+#endif
 #if defined(_MSC_VER) && defined(_M_X86)
+#ifndef OPERA_SMALL_VERSION
 	static int have_tsc = 1;
+#endif
 	DWORD cyclecount;
 
 	if (have_tsc) {
@@ -660,6 +686,7 @@
 	}
 }
 
+#ifndef OPERA_SMALL_VERSION
 /* feed screen contents to PRNG */
 /*****************************************************************************
  *
@@ -719,7 +746,7 @@
     /* Now go through the whole screen, repeatedly grabbing n lines */
     for (y = 0; y < h-n; y += n)
     	{
-	unsigned char md[MD_DIGEST_LENGTH];
+	unsigned char md[MD_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	/* Bitblt screen DC to memory DC */
 	BitBlt(hMemDC, 0, 0, w, n, hScrDC, 0, y, SRCCOPY);
@@ -746,5 +773,6 @@
   DeleteDC(hScrDC);
 #endif /* !OPENSSL_SYS_WINCE */
 }
+#endif // !OPERA_SMALL_VERSION
 
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/rand/randfile.c openssl-1.0.0q/crypto/rand/randfile.c
--- openssl-1.0.0q.orig/crypto/rand/randfile.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/randfile.c	2017-04-25 16:23:40.614620849 +0200
@@ -59,24 +59,32 @@
 /* We need to define this to get macros like S_IFBLK and S_IFCHR */
 #define _XOPEN_SOURCE 500
 
+#ifndef OPERA_SMALL_VERSION
 #include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "e_os.h"
 #include <openssl/crypto.h>
 #include <openssl/rand.h>
 #include <openssl/buffer.h>
 
+#ifndef OPENSSL_NO_RAND_FILE
+
 #ifdef OPENSSL_SYS_VMS
 #include <unixio.h>
 #endif
 #ifndef NO_SYS_TYPES_H
+#ifndef OPERA_SMALL_VERSION
 # include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifndef OPENSSL_NO_POSIX_IO
+#ifndef OPERA_SMALL_VERSION
 # include <sys/stat.h>
+#endif /* !OPERA_SMALL_VERSION */
 # include <fcntl.h>
 #endif
 
@@ -109,7 +117,7 @@
 	/* If bytes >= 0, read up to 'bytes' bytes.
 	 * if bytes == -1, read complete file. */
 
-	MS_STATIC unsigned char buf[BUFSIZE];
+	MS_STATIC unsigned char buf[BUFSIZE]; /* ARRAY OK 2004-02-18 yngve */
 #ifndef OPENSSL_NO_POSIX_IO
 	struct stat sb;
 #endif
@@ -179,7 +187,7 @@
 
 int RAND_write_file(const char *file)
 	{
-	unsigned char buf[BUFSIZE];
+	unsigned char buf[BUFSIZE]; /* ARRAY OK 2004-02-18 yngve */
 	int i,ret=0,rand_err=0;
 	FILE *out = NULL;
 	int n;
@@ -276,16 +284,20 @@
 	struct stat sb;
 #endif
 
+#ifndef GROUP_USER_ID_IS_MEANINGLESS
 	if (OPENSSL_issetugid() == 0)
+#endif
 		s=getenv("RANDFILE");
-	if (s != NULL && *s && strlen(s) + 1 < size)
+	if (s != NULL && *s && op_strlen(s) + 1 < size)
 		{
 		if (BUF_strlcpy(buf,s,size) >= size)
 			return NULL;
 		}
 	else
 		{
+#ifndef GROUP_USER_ID_IS_MEANINGLESS
 		if (OPENSSL_issetugid() == 0)
+#endif
 			s=getenv("HOME");
 #ifdef DEFAULT_HOME
 		if (s == NULL)
@@ -293,7 +305,7 @@
 			s = DEFAULT_HOME;
 			}
 #endif
-		if (s && *s && strlen(s)+strlen(RFILE)+2 < size)
+		if (s && *s && op_strlen(s)+op_strlen(RFILE)+2 < size)
 			{
 			BUF_strlcpy(buf,s,size);
 #ifndef OPENSSL_SYS_VMS
@@ -325,3 +337,5 @@
 #endif
 	return(buf);
 	}
+
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/rand/randtest.c openssl-1.0.0q/crypto/rand/randtest.c
--- openssl-1.0.0q.orig/crypto/rand/randtest.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rand/randtest.c	2017-04-25 16:23:40.615620697 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/rand.h>
 
 #include "../e_os.h"
diff -Naur openssl-1.0.0q.orig/crypto/rc2/.gitignore openssl-1.0.0q/crypto/rc2/.gitignore
--- openssl-1.0.0q.orig/crypto/rc2/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/.gitignore	2017-04-25 16:23:40.616621383 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/rc2/opera_rc2_ecb.c openssl-1.0.0q/crypto/rc2/opera_rc2_ecb.c
--- openssl-1.0.0q.orig/crypto/rc2/opera_rc2_ecb.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/opera_rc2_ecb.c	2017-04-25 16:23:40.617621510 +0200
@@ -0,0 +1,13 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+#include "rc2_ecb.c"
+#endif /* _SSL_USE_OPENSSL_ */
diff -Naur openssl-1.0.0q.orig/crypto/rc2/opera_rc2ofb64.c openssl-1.0.0q/crypto/rc2/opera_rc2ofb64.c
--- openssl-1.0.0q.orig/crypto/rc2/opera_rc2ofb64.c	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/opera_rc2ofb64.c	2017-04-25 16:23:40.618621079 +0200
@@ -0,0 +1,13 @@
+/* -*- Mode: c++; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*-
+**
+** Copyright (C) 1995-2005 Opera Software AS.  All rights reserved.
+**
+** This file is part of the Opera web browser.  It may not be distributed
+** under any circumstances.
+*/
+
+#include "core/pch.h"
+
+#ifdef _SSL_USE_OPENSSL_
+#include "rc2ofb64.c"
+#endif /* _SSL_USE_OPENSSL_ */
diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2_cbc.c openssl-1.0.0q/crypto/rc2/rc2_cbc.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2_cbc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2_cbc.c	2017-04-25 16:23:40.619620926 +0200
@@ -56,6 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_RC2
 #include <openssl/rc2.h>
 #include "rc2_locl.h"
 
@@ -224,3 +229,4 @@
 	d[1]=(unsigned long)(x2&0xffff)|((unsigned long)(x3&0xffff)<<16L);
 	}
 
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2_ecb.c openssl-1.0.0q/crypto/rc2/rc2_ecb.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2_ecb.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2_ecb.c	2017-04-25 16:23:40.619620926 +0200
@@ -60,7 +60,9 @@
 #include "rc2_locl.h"
 #include <openssl/opensslv.h>
 
-const char RC2_version[]="RC2" OPENSSL_VERSION_PTEXT;
+#ifndef OPERA_SMALL_VERSION
+const char RC2_version[]="RC2" OPENSSL_VERSION_PTEXT; /* ARRAY OK 2008-02-26 haavardm */
+#endif
 
 /* RC2 as implemented frm a posting from
  * Newsgroups: sci.crypt
diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2_skey.c openssl-1.0.0q/crypto/rc2/rc2_skey.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2_skey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2_skey.c	2017-04-25 16:23:40.621622018 +0200
@@ -56,6 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifndef OPENSSL_NO_RC2
 #include <openssl/rc2.h>
 #include "rc2_locl.h"
 
@@ -143,3 +148,4 @@
 #if defined(_MSC_VER)
 #pragma optimize("",on)
 #endif
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2cfb64.c openssl-1.0.0q/crypto/rc2/rc2cfb64.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2cfb64.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2cfb64.c	2017-04-25 16:23:40.621622018 +0200
@@ -56,6 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
+#include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+#ifdef OPENSSL_USE_CFB_CIPHERS
+#ifndef OPENSSL_NO_RC2
 #include <openssl/rc2.h>
 #include "rc2_locl.h"
 
@@ -120,3 +126,5 @@
 	*num=n;
 	}
 
+#endif
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/rc2/rc2speed.c openssl-1.0.0q/crypto/rc2/rc2speed.c
--- openssl-1.0.0q.orig/crypto/rc2/rc2speed.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/rc2/rc2speed.c	2017-04-25 16:23:40.623621435 +0200
@@ -63,7 +63,9 @@
 #define TIMES
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include <openssl/e_os2.h>
 #include OPENSSL_UNISTD_IO
@@ -74,10 +76,14 @@
 #endif
 
 #ifndef _IRIX
+#ifndef OPERA_SMALL_VERSION
 #include <time.h>
+#endif /* !OPERA_SMALL_VERSION */
 #endif
 #ifdef TIMES
+#ifndef OPERA_SMALL_VERSION
 #include <sys/types.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/times.h>
 #endif
 
@@ -95,7 +101,9 @@
 
 #if defined(sun) || defined(__ultrix)
 #define _POSIX_SOURCE
+#ifndef OPERA_SMALL_VERSION
 #include <limits.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/param.h>
 #endif
 
